# module Gem::DefaultUserInteraction

`Module` that defines the default `UserInteraction`. Any class including this module will have access to the `ui` method that returns the default UI.

### Public Class Methods

ui() click to toggle source

Return the default UI.

    # File lib/rubygems/user_interaction.rb, line 29
    def self.ui
      @ui ||= Gem::ConsoleUI.new
    end

ui=(new_ui) click to toggle source

`Set` the default UI. If the default UI is never explicitly set, a simple console based `UserInteraction` will be used automatically.

    # File lib/rubygems/user_interaction.rb, line 37
    def self.ui=(new_ui)
      @ui = new_ui
    end

use_ui(new_ui) { || ... } click to toggle source

Use `new_ui` for the duration of `block`.

    # File lib/rubygems/user_interaction.rb, line 44
    def self.use_ui(new_ui)
      old_ui = @ui
      @ui = new_ui
      yield
    ensure
      @ui = old_ui
    end

### Public Instance Methods

ui() click to toggle source

See `DefaultUserInteraction::ui`

    # File lib/rubygems/user_interaction.rb, line 55
    def ui
      Gem::DefaultUserInteraction.ui
    end

ui=(new_ui) click to toggle source

See `DefaultUserInteraction::ui=`

    # File lib/rubygems/user_interaction.rb, line 62
    def ui=(new_ui)
      Gem::DefaultUserInteraction.ui = new_ui
    end

use_ui(new_ui, &block) click to toggle source

See `DefaultUserInteraction::use_ui`

    # File lib/rubygems/user_interaction.rb, line 69
    def use_ui(new_ui, &block)
      Gem::DefaultUserInteraction.use_ui(new_ui, &block)
    end